#!
use strict;         # check for proper code
use Expect;         # change keysourrce

# (c) Guenther Alka, 2018-2020
# mar 08, 2018, solaris enc, thanks martin
# 17. feb 2020, omnios

###############     # configure autolock
sub my_action {
###############

require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/keyserverlib.pl";  # common subs

 # list overview
 &verify_keyfolder;           # check local1, local2 and keyserver folder

 #edit?
 if (($in{'action'} =~/edit/) && ($in{'answered'} ne "1")) { &lock_ask_property; }

 # update
 if (($in{'action'} =~/edit/) && ($in{'answered'} eq "1")) { &lock_change_property; }

 &my_list_overview;

} #/ my_action


############
sub my_encsettings {
###########
  #header
  my ($i,$r,$err,$status);

  my $s='&nbsp;' x 20;
  my @e=("<b>Property</b>\t<b>Value</b$s\t<b>Status$s\t<b>Info$s\n");

  $err="<b class='font_darkred'>error</b>";

  #hostid
  $i="missing";
  if ($cfg{'value_key_hostid'}=~/\w+/) { $i="ok"; }
  push(@e,"Hostkey\t$cfg{'value_key_hostid'}\t$i\tThis key is set on the keyserver to identify this host and must be copied to ZFS  Filesystems &gt; Encryption &gt; Settings");

  #split
  $i="missing";
  if ($cfg{'select_key_split'}=~/\w/)  { $i="ok"; }       # all, local, web, none
  push(@e,"Keysplit\t$cfg{'select_key_split'}\t$i\tThis value is set in  ZFS  Filesystems &gt; Encryption &gt; Defaults for new filesystems");

  #keydata fs1 (L1)
  $i="not set";
  if ($cfg{'value_keydata_fs'}=~/\/\w/) {
     $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "1") {
       $i="ok";
     } else {
       $i="$err, path not available";
     }
  }
  push(@e,"L1 path\t$cfg{'value_keydata_fs'}\t$i\tFolder for local keys");

  #keydata fs2 (L2) from enc settings
  $i="not set";
  if ($cfg{'value_keydata_fs'}=~/\/\w/) {
     $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "1") {
       $i="ok";
     } else {
       $i="$err, path not available";
     }
  }
  push(@e,"L2 path\t$cfg{'value_keydata_fs'}\t$i\tFolder for local keys with second part of a key in this folder");


  #W1
  $i="not set";
  if ($cfg{'value_key_server1'}=~/:\/\/\w/) {    # http(s)://..
    $t=$p{'key_par'}; $t=~s/hostid=/hostid=$cfg{'value_key_hostid'}/; $t=~s/action=/action=check/;
    $i=&call_key_web($cfg{'value_key_server1'},"$t");            # keylib  webserver, data
    $i=~s/error/$err/;
    if ($i=~/ok/) { $current{'W1'}="1"; }
  }
  push(@e,"W1 Url\t$cfg{'value_key_server1'}\t$i\tKeyserver-1 url where keypart-1 is stored ex https://keyserver1.abc.com");

  #W2
  $i="not set";
  if ($cfg{'value_key_server2'}=~/:\/\/\w/) {    # http(s)://..
    $t=$p{'key_par'}; $t=~s/hostid=/hostid=$cfg{'value_key_hostid'}/; $t=~s/action=/action=check/;
    $i=&call_key_web($cfg{'value_key_server2'},"$t");            # keylib  webserver, data
    $i=~s/error/$err/;

    if ($i=~/ok/) { $current{'W2'}="1"; }
  }
  push(@e,"W2 Url\t$cfg{'value_key_server2'}\t$i\tKeyserver-2 url where keypart-2 is stored ex https://keyserver2.abc.com");

  #W1'

  $i="not set";
  if ($cfg{'value_key_server1b'}=~/:\/\/\w/) {    # http(s)://..
    $t=$p{'key_par'}; $t=~s/hostid=/hostid=$cfg{'value_key_hostid'}/; $t=~s/action=/action=check/;
    $i=&call_key_web($cfg{'value_key_server1b'},"$t");            # keylib  webserver, data
    $i=~s/error/$err/;
    if ($i=~/ok/) { $current{'W1b'}="1"; }
  }
  push(@e,"W1\' Url\t$cfg{'value_key_server1b'}\t$i\tRedundant keyserver-1b url where keypart-1 can be requested on an outage of W1 ex https://keyserver3.abc.com");

  #W2'
  $i="not set";
  if ($cfg{'value_key_server2b'}=~/:\/\/\w/) {    # http(s)://..
    $t=$p{'key_par'}; $t=~s/hostid=/hostid=$cfg{'value_key_hostid'}/; $t=~s/action=/action=check/;
    $i=&call_key_web($cfg{'value_key_server2b'},"$t");            # keylib  webserver, data
    $i=~s/error/$err/;
    if ($i=~/ok/) { $current{'W2b'}="1"; }
  }
  push(@e,"W2\' Url\t$cfg{'value_key_server2b'}\t$i\tRedundant keyserver-2b url where keypart-2 can be requested on an outage of W2 ex https://keyserver4.abc.com");

  #cgi
  push(@e,"\nCGI values\t$p{'key_par'}\tok\tThese values are used to contact a keyserver");

  #keyserver
  push(@e,"Keyserver data\t$cfg{'value_keyserver_fs'}\tok\tKeyserver data folder");

  $r=join("\n",@e);
  # print table
  print "<b>Settings</b><br>";
  print &list2table($r);

  print "<br><br>";
  print "<b>Filesystems</b><br>";
  &exe("echo 'end my_settings'");

  #debug
  #&print_hash(%cfg);

}

 ######################
 sub lock_change_property {                 #hide:
 #######################    set  details
 my ($do,$r,$t,@c,$w,@w,$ok,$k);

 #read config
 ###################
  @c=();
  if (-f "/var/web-gui/_log/autolock/_settings/autolock.cfg") {          # fs        autolock_enable          timetable   userlock_allow        key_source  (use tab)
    open (F,"</var/web-gui/_log/autolock/_settings/autolock.cfg");
        flock(F, LOCK_EX);
        @c=<F>;
    close (F);
    foreach my $c (@c) { chomp($c); }
  }

 #debug
 #&print_hash(%in);

 # check if filesystem that you want to update is in settings
 $do="1";
 foreach my $c (@c) {
     @w=();
     @w=split(/\t/,$c);    # fs      autolock   timetable    source
     if ($w[0] eq "$in{'list'}") { $do="0"; last; }
 }
 if ($do) {
   push (@c,"$in{'list'}\tno\tnone\tno\tnone");
 }

 $do="";


 #### lockstatus from zfslib
 if ($in{'action'} eq "edit-lockstatus") {
        &zfslib_change_property;       # does reload
        $in{'action'}="";
        $in{'property'}="";
        &reload;
 }



 #### automount  (zfs property)
  if ($in{'action'} eq "edit-automount") {
        print "please wait, update settings..\n";
        &exe("zfs set enc_automount:=$in{'text'} $in{'list'}");
        $in{'action'}="";
        &reload;

  }

 #### autolock  (zfs property)
  if ($in{'action'} eq "edit-autolock") {
        print "please wait, update settings..\n";
        &exe("zfs set enc_autolock:=$in{'text'} $in{'list'}");
        $in{'action'}="";
        &reload;

  }

 #### smb userlock  (zfs property)
  if ($in{'action'} eq "edit-userlock") {
        print "please wait, update settings..\n";
        &exe("zfs set enc_userlock:=$in{'text'} $in{'list'}");
        $in{'action'}="";
        &reload;

  }

 #### auto timetable  (zfs property)
  if ($in{'action'} eq "edit-timetables") {
        print "please wait, update settings..\n";
        &exe("zfs set enc_timetable:=$in{'text'} $in{'list'}");
        $in{'action'}="";
        &reload;
  }


  #### keysplit  (zfs property)
  if ($in{'action'} eq "edit-method") {
        print "please wait, update settings..\n";
        &exe("zfs set enc_split:=$in{'text'} $in{'list'}");
        $in{'action'}="";
        &reload;
  }


   #&print_hash(%in);
   &mess("unexpected end");

  #### source ## nur Solaris, obsolete?
  if (($in{'action'} eq "edit-keysource") && (0)) {             # modify filesystem property, not config file
        print "please wait, update settings..\n";

        $ok="0";
        if ($in{'text'}=~/pkcs11/i) {
              $ok="0";
        } else {
              $in{'text'}=~s/ +//g;
              if (!($in{'text'}=~/^passphrase|^hex|^raw/i))          { $ok="1";  }
              if (!($in{'text'}=~/,file:\/\/\/\w+|,https:\/\/\w+/i)) { $ok="1";  }
        }

        # prompt is critical as it define a new key, must be done by an admin at console
        if ($in{'text'}=~/prompt/i) {    $ok="1"; }

        if ($ok) {
           &mess("keysource must consist of a type like passphrase and a source like https or file<br><br>passphrase,file:///xx (for file /xx) or<br>passphrase,https://url <br><br>prompt that defines a new key is critical and must be set by an admin at console");
        }

        # step 1 unload the key
        print "unload key<br>";
        print &exe("zfs key -u -f $in{'list'} 2>&1");


        #obsolet ########

        # step , load the key via prompt
        #     use Expect;

        print "load key<br>";
        $in{'key'}=~s/\s//gs;

        my $exp;  #->raw_pty(1);
        $exp = Expect->spawn("sudo $sys{'sbinpath'}zfs key -l $in{'list'} 2>&1") or die "Couldn't mount: $!\n";

        $exp->expect(1,
                [ 'Enter' =>
                         sub {
                             $exp->send("$in{'key'}\r");
                             print "<br>";
                             exp_continue;
                         }
                ]
        );
        $exp->soft_close();

        # step 3. set new keysource
        print "<br>modify keysource<br>";
        print &exe("zfs key -c -o keysource=$in{'text'} $in{'list'} 2>&1");
        sleep(5);

        $in{'action'}="";
        &reload;


        # step 2. set new keysource
        print "<br>modify keysource<br>";
        print &exe("zfs key -c -o keysource=$in{'text'} $in{'list'} 2>&1");
        sleep(2);

        $in{'action'}="";
        &reload;
        #foreach my $c (@c) {
        #     @w=();
        #     @w=split(/\t/,$c);    # fs   autolock   timetable  userlock
        #
        #     if ($in{'list'} eq $w[0]) {
        #        $in{'text'}=~s/ +$|^ +//g;

        #        $w[4]=$in{'text'};
        #        $do="1";
        #        $c=join("\t",@w);
        #        last;
        #     }
        #}
  }



  ############
  if ($do) {
    $t=join("\n",@c);

    open (PF, ">/var/web-gui/_log/autolock/_settings/autolock.cfg");
      flock(PF, LOCK_EX);
      print PF "$t";
    close (PF);
  }

  $in{'action'}="";
  &reload;

} #/sub


#######################
sub lock_ask_property {        #hide:
#######################

    my ($ask,$close,$form,$info,$t,$opt,$r,$do,$hn);
    $close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>$txt{'cancel'}</b></a>";


    #&print_hash(%in);
    # lock/unlock from zfslib
    if ($in{'action'} eq "edit-lockstatus") {
      $in{'pass'}=$in{'key'};
      $in{'zfs'}=$in{'list'};
      if ($in{'old'}=~/unlocked/) {      # <b>locked</b
           $in{'prop'}="lock";
       } else {
           $in{'prop'}="unlock";
       }
       $form=&zfslib_ask_property;     # show form lock/unlock
       print $form;
       return;
    }

    #automount yes/no
    if ($in{'action'} eq "edit-automount") {
        $do="1";
        $t="yes";
        if ($in{'old'} eq "yes") { $t="no"; }
        if (!($cfg{'ver'}=~/\w/)) { $t="no"; } #only

        $form="switch automount to: <input type='text' name='text' value=\"$t\" style='width: 120px; margin-left:4px' readonly><br>";
        $info="Automount 'yes' means that the filesystem is unlocked at bootup";
    }


    #autolock yes/no/smb
    if ($in{'action'} eq "edit-autolock") {
        $do="1";
        $t="yes";
        if ($in{'old'} eq "yes") { $t="no"; }
        if (!($cfg{'ver'}=~/\w/)) { $t="no"; } #only
        $form="switch autolock to: <input type='text' name='text' value=\"$t\" style='width: 120px; margin-left:4px' readonly><br>";
        $info="Autolock 'yes' means that the lockservice can unlock/lock the filesystem according to the timetable.";
    }


    #userlock=autofolder yes/no,smblock
    if ($in{'action'} eq "edit-userlock") {
        $do="1";
        $t="yes,no,smbkey";
        if (!($cfg{'ver'}=~/\w/)) { $t="no"; } #only
        $form="Switch userlock to:".&select('text',$t,$in{'old'});
        $info="Userlock 'yes' means that the lockservice can unlock/lock depending user actions on monitored autolock folders.";
        $info.="With Smbkey the controlfile =switcher.move for an unlock in User_encrypt must contain the SMB key";
    }

    #timetable
    if ($in{'action'} eq "edit-timetables") {
        $do="1";

        @p=();
        &read_dir("/var/web-gui/_log/autolock/timetables/",'p','\.cfg$');
        @p=sort(@p);

        $opt="none,";

        # show all (default and my)
        foreach my $p (@p) {
           $p=~s/\.cfg//;
                $opt.="$p,";
        }
        $opt=~s/,$//;

        if (!($cfg{'ver'}=~/\w/)) { $opt="none"; } #only
        $form="set timetable $in{'list'} to: ";
        $form.=&select('text',$opt,$in{'old'});

        $info="A timetable sets unlock/lock times. <br>";
        $info.="If you select a default timetable like 01_business_hours and a private one with same name but starting<br>";
        $info.=" with an uppercase character is found like 01_Business_hours the private one is used instead.";
    }


    # keysplit method
    if ($in{'action'} eq "edit-method") {
        $do="1";

        $opt="none,L1:L1,L1:L2,W1:W1,W1:W2,L1:W1";
        if (!($cfg{'ver'}=~/\w/)) { $opt="none,L1:L1,W1:W1"; } #only

        $form="set keysplit method to $in{'list'} to: ";
        $form.=&select('text',$opt,$in{'old'});

        $info="Keysplit method:<br>";
        $info.="An encryption key is splitted and the two parts can be stored (L)ocally or a (W)ebserver<br>";
        $info.="When using a webserver, high availablity with a second webserver (pair) is possible.";
    }


    #keysource, Solaris, obsolete?
    if (($in{'action'} eq "edit-keysource") && (0)) {
        $do="1";

        $t=&exe("zfs get -H -o value keystatus $in{'list'}");
        chomp($t);

        if ($t ne "available") {
            &mess("Please unlock encrypted filesystem $in{'list'} first");
        }

        $t=&exe("zfs get -H -o value keysource $in{'list'}");
        chomp($t);

        $form="<table>";

        # prompt -> file
        if ($t=~/prompt/) {
          $form.="<tr><td>current Key: </td><td><input type='password' name='key' value=\"\" style='width: 340px; margin-left:4px'></td></tr>";
        }

        $form.="<tr><td>new Key source: </td><td><input type='text' name='text' value=\"$in{'old'}\" style='width: 340px; margin-left:4px'><br><br></td></tr>";
        $form.="</table>";

        $info="A keysorce is a reference to your key to unlock a filesystem. Autolock requires a file or webbased method<br><br>";
        $info.="</i><b>Your only options for auto/userlock are:</b><br>passphrase,file:///pool/filename <br>passphrase,https://url <br><br>or optionally<br>";

        $info.="passphrase,prompt (use Console command zfs key -c -o keysource=passphrase,prompt zfs)<br>pkcs11:<i><br><br>";
        $info.="Use filekeys on a pool built on a USB stick or better an iSCSI LUN from another server like /pool2/keys/fs1.key<br>";
        $info.="Do not store the keys on this server. Prompt is only an option with autolock=lock only. <br><br>";
        $info.="<font style='color:red'> This function locks the filesystem when trying to modify the keysource.</font>";
    }

     ### form ###
     if ($do) {
        print &ask_pop("$form","$info","$opt");
     }


} #/sub

####################   # list overview
sub my_list_overview {
####################

  my ($url,$ask,$u,$out,$var,$r,@e,@c,@r,$w,@w,$ok,$s,$k,$ks,$ls,$smb,$r,$p,$fsid,$split,$err);  # declare all your variables as local or you will get errors

  $err="<b class='font_darkred'>no</b>";

  # show settings
  &my_encsettings;

  #url
    $url="<a title='=title=' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action==action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm('=ask2=?'))\"";

  # parse setup

  if (!(-d "/var/web-gui/_log/autolock")) {
    mkdir ("/var/web-gui/_log/autolock");
    &exe("chmod 700 /var/web-gui/_log/autolock");
  }
  if (!(-d "/var/web-gui/_log/autolock/timetables")) {
    mkdir ("/var/web-gui/_log/autolock/timetables");
    &exe("chmod 700 /var/web-gui/_log/autolock/timetables");
  }
  if (!(-d "/var/web-gui/_log/autolock/aliases")) {
    mkdir ("/var/web-gui/_log/autolock/aliases");
    &exe("chmod 700 /var/web-gui/_log/autolock/aliases");
  }


  # read enc filesystems a
  $r=&exe("zfs list -H -o name -t filesystem | grep -v rpool | grep /");         # all fs name without rpool and datapool
  @r=split(/\n/,$r);

  #check for encrypted fs
  $t='&nbsp;' x 10;
  @e=("<b>Filesystem</b>$t\t<b>Enc</b>\t<b>Method</b>\t<b>Lockstatus</b>\t<b>Auto-Mount</b>\t<b>Auto-Lock</b>\t<b>Auto-Timetable</b>\t\t<b>Keytype</b>\t<b>Keymethod</b>\t<b>Keysplit</b>\t<b>Keyp1</b>\t<b>Keyp2</b>\t<b>Keyp1\'</b>\t<b>Keyp2\'</b>\t\t<b>SMB\&nbsp;Share\&nbsp;on\&nbsp;unlock</b>$t\t<b>SMB Userlock</b>\t<b>SMB Key</b>$t\n");

  # add values
  foreach my $fs (@r) {
     $w=&exe("zfs get -H -o name,value,source encryption $fs 2>/dev/null");       # name property value source
     chomp($w);                                      # ex tank/data encryption aes-256-ccm local

     if ($w eq "")             { next; }
     if (!($w=~/\s+aes\-\d+/)) { next; }               # not encrypted

### martingo 20180307 >>> Filesystems ueberspringen, die ein verschluesseltes Parent haben
         next if ( &exe("$sys{'sbinpath'}zfs get -H keysource $fs") =~ /inherited from / );
### <<<

     $fsid=$fs; $fsid=~s/ +.*//; $fsid=~s/\//~/g;
     $smb="-";      # smb access key

     #add lockstatus from keystatus
     #if ($sys{'auto_os'} eq "Solaris 11") { }
     $t=&exe("zfs get -H -o value keystatus $fs"); chomp($t);          # Solaris and Ill

     # Lockstatus
     $ls="-";
     if ($t eq "available")   { $t="unlocked"; $ls=$t; }
     if ($t eq "unavailable") { $t="<b class='font_darkred'>locked</b>";   $ls=$t; }

     $w.="\t$t";  # (un)available -> locked/unlocked

     #automount:
     $t=&exe("zfs get -H -o value enc_automount: $fs");   chomp($t);   # Solaris and Ill
     if ($t eq "yes") {
        $w.="\tyes";
     } else {
        $w.="\tno";
     }

     #autolock functionality:
     $t=&exe("zfs get -H -o value enc_autolock: $fs");   chomp($t);        # Solaris and Ill
     if ($t eq "yes") {
        $w.="\tyes";
     } else {
        $w.="\tno";
     }

     #auto timetable:
     $t=&exe("zfs get -H -o value enc_timetable: $fs");   chomp($t);   # Solaris and Ill
     if ($t =~/\w/) {
        $w.="\t$t";
     } else {
        $w.="\tnone";
     }

     # space
     $w.="\t";

     # keysource + location
     if ($sys{'auto_os'}=~/Solaris/i)  {     # ex  keysource=passphrase,prompt
         $t=&exe("zfs get -H -o value keysource $fs");   chomp($t);            # Solaris
         $t=~s/,/\t/;
         $w.="\t$t";
     } else {                                # keyformat=passphrase -o keylocation=prompt
          $t=&exe("zfs get -H -o value keyformat $fs");      chomp($t);         # openzfs
          $t.="\t";
          $t.=&exe("zfs get -H -o value keylocation $fs");   chomp($t);
          $w.="\t$t";
     }

     # keysplit
     $split=&exe("zfs get -H -o value enc_split: $fs");   chomp($split);            # Solaris and Ill
     if ($split =~/:/) {
        $w.="\t$split";
     } else {
        $w.="\tnone";
     }

     #keypart1, depends on keysplit (L1 or W1)
     #########################################
        $t="-";
        if ($split=~/L1:/) {

           #
           $r=`sudo test -f "/$cfg{'value_keydata_fs'}/local/keys-part1/$fsid.kp1" && echo 1 || echo 2`;  chomp($r);
           if ($r eq "2") {
             $t="n.a.";
           }  else {

             $r=`sudo cat /$cfg{'value_keydata_fs'}/local/keys-part1/$fsid.kp1`;
             if ($r =~/\w+/) {  $smb=&key_get_smbak($r); $t="ok";  } else { $smb="key-1 not found"; $t="$err"; }
           }
        }

        if ($split=~/W1:/) {

           #

           if ($current{'W1'}) {       # server available from overview
             $r=&my_read_web($cfg{'value_key_server1'},$fsid,'1');   # server, fsid, part

             if ($r=~/ok/) {
                  $t="ok";
                  $r=~s/.*ok, //;

                  $smb=&key_get_smbak($r);

                  if (!($smb =~/\w+/)) { $smb="key-1 not found"; }

             } else {
                  $smb="key-1 not found";
                  $r=~s/.*,//; $t="$err<br>$r";
             }
           }  else { $t="n.a."; }

        }
     $w.="\t$t";


     #keypart2
     #########
        $t="-";
        if ($split=~/:L1/) {
           #
           $r=`sudo test -f "/$cfg{'value_keydata_fs'}/local/keys-part2/$fsid.kp2" && echo 1 || echo 2`;  chomp($r);
           if ($r eq "2") {
             $t="n.a.";
           }  else {
             $r=`sudo cat /$cfg{'value_keydata_fs'}/local/keys-part2/$fsid.kp2 2>/dev/null`;
             if ($r =~/\w+/) {  $smb=&key_get_smbak($r); $t="ok"; } else { $smb="key-1 not found"; $t="$err"; }
           }
        }

        if ($split=~/:L2/) {
           #
           $r=`sudo test -f "/$cfg{'value_keydata_fs2'}/local/keys-part2/$fsid.kp2" && echo 1 || echo 2`;  chomp($r);
           if ($r eq "2") {
             $t="n.a.";
           }  else {
             $r=`sudo cat /$cfg{'value_keydata_fs2'}/local/keys-part2/$fsid.kp2`;
             if ($r =~/\w+/) {  $t="ok"; } else { $smb="key-1 not found"; $t="$err"; }
           }
#&print_hash(%p);
#&mess("/$p{'keydata_fs2'}/local/keys-part2/$fsid.kp2<hr>$r");
        }

        if ($split=~/:W1/) {         # keypart2
           #
           if ($current{'W1'}) {       # server available from overview
             $r=&my_read_web($cfg{'value_key_server1'},$fsid,'2');   # server, fsid, part
             if ($r=~/ok/) {
                  $t="ok";
             } else { $r=~s/.*,//; $t="$err<br>$r"; }

           }  else {  # w1b
               if ($current{'W1b'}) {                           # server available from overview
                 $r=&my_read_web($cfg{'value_key_server1'},$fsid,'2');  # server, fsid, part
                 if ($r=~/ok/) {
                    $t="ok'";
                 } else { $t=$err;  }

               } else {
                 $t="n.a.";
               }
           }
        }

        if ($split=~/:W2/) {
           #
           if ($current{'W2'}) {                             # server available from overview
              $r=&my_read_web($cfg{'value_key_server2'},$fsid,'2');   # server, fsid, part
              if ($r=~/ok/) { $t="ok"; } else { $r=~s/.*,//; $t="$err<br>$r"; }

           }  else { $t="n.a."; }
        }
     $w.="\t$t";


     #keypart1'  W1'
     ##################
     $t="-";

     if ($split=~/W1:/) {
           #
           if ($current{'W1b'}) {                               # server available from overview
               $r=&my_read_web($cfg{'value_key_server1b'},$fsid,'1');   # server, fsid, part
               if ($r=~/ok/) { $t="ok"; } else { $r=~s/.*, //; $t="$err<br>$r"; }
#$smb.="-";
               if (($smb=~/\-/) && ($r=~/ok, [A-Za-z0-9]+/)) {                                # not found on W1
                    #$smb.="<br>". &key_get_smbak($r);         # show W1 and W1' (debug only) or
                    $smb=&key_get_smbak($r);                   # show W1 or W1'

               }
#if ($fs =~/11/) { &mess("$fs<br>$r<hr>$smb<hr>$t"); }
           }  else { $t="n.a."; }

     }

     $w.="\t$t";


     #keypart2'  W only
     ##################
     $t="-";
     if ($split=~/:W1/) {
       if ($current{'W1b'}) {
         $r=&my_read_web($cfg{'value_key_server1b'},$fsid,'2');   # server, fsid, part2
         if ($r=~/ok/) { $t="ok"; } else { $r=~s/.*,//; $t="$err<br>$r"; }
       } else { $t="n.a."; }
     }

     if ($split=~/:W2/) {
       if ($current{'W2b'}) {
         $r=&my_read_web($cfg{'value_key_server2b'},$fsid,'2');   # server, fsid, part2
         if ($r=~/ok/) { $t="ok"; } else { $r=~s/.*,//; $t="$err<br>$r"; }
       } else { $t="n.a."; }
     }
     $w.="\t$t";

     # space
     $w.="\t";

     #smbshare
     $t=&exe("zfs get -H -o value enc_smbshare: $fs");   chomp($t);            # Solaris and Ill
     if ($t =~/[a-zA-Z0-9]/) {
        $w.="\t$t";
     } else {
        $w.="\t-";
     }

     #smb userlock enabled:
     if ($smb =~/\w+/) {
       $t=&exe("zfs get -H -o value enc_userlock: $fs");   chomp($t);  # Solaris and Ill
       if (!($t=~/yes|no|smbkey/)) {
         $w.="\tno";
       } else {
         $w.="\t$t";
       }
     }

     #smb ak:
     $w.="\t$smb";

     # space and
   #  $w.="  \t";

     ##
     push(@e,"$w");
  }
  ###############
#&print_array(@e);

  # no enc fs
  if (@e<2) {       # only header
      &log_end;
      print "<script language='javascript'>document.getElementById('hl').innerHTML='Encrypted filesystems with with Autolock/user unlock/lock service (Pro feature)'</script>\n";
      push(@e,"no encrypted filesystems");
     # exit;
  }


  # set url/ add editlink
  #

  if ($url ne "") {
    foreach my $c (@e) {                         # fs  type method source keystat  ""  autolock  timetable  userlock  smbkey smbshare  key_source  keylocation  keyavail (tabsep)
                                                 #  0     1      2      3       4   5         6          7         8       9       10          11           12        13

       if ($c=~/Filesystem/) { next; }           # header

       @w=();
       @w=split(/\t/,$c);

       #debug
       # &print_array(@w);

       # name, enc, method, lockstatus, automount, autolock, autotime, autofolder, '' , keytype, method, split, keyp1..4, '', smbshare, smbkey
       #    0    1       2           3          4         5         6            7  8          9      10     11    12-15  16        17      18

       # 3 Lockstatus
         $t=$w[3];
         $w[3]=$url;
         $w[3]=~s/=text=|=old=/$t/g;         $w[3]=~s/=title=|=prop=/lockstatus/g;
         $w[3]=~s/=action=/edit-lockstatus/; $w[3]=~s/=list=/$w[0]/;

       # 4 Automount
         $t=$w[4];
         $w[4]=$url;
         $w[4]=~s/=text=|=old=/$t/g;         $w[4]=~s/=title=|=prop=/automount/g;
         $w[4]=~s/=action=/edit-automount/;  $w[4]=~s/=list=/$w[0]/;

       # 5 autolock enable
         $t=$w[5];
         $w[5]=$url;
         $w[5]=~s/=text=|=old=/$t/g;         $w[5]=~s/=title=|=prop=/autolock/g;
         $w[5]=~s/=action=/edit-autolock/;   $w[5]=~s/=list=/$w[0]/;

       # 6 autotimetable
         $t=$w[6];
         $w[6]=$url;
         $w[6]=~s/=text=|=old=/$t/g;         $w[6]=~s/=title=|=prop=/timetables/g;
         $w[6]=~s/=action=/edit-timetables/; $w[6]=~s/=list=/$w[0]/;

       # method edit manually

       # split
         $t=$w[10];
         $w[10]=$url;
         $w[10]=~s/=text=|=old=/$t/g;          $w[10]=~s/=title=|=prop=/keysplit/g;
         $w[10]=~s/=action=/edit-method/;      $w[10]=~s/=list=/$w[0]/;

       # 17 smb userlock allowed
         if ($w[17] ne "n.a.") {
          $t=$w[17];
          $w[17]=$url;
          $w[17]=~s/=text=|=old=/$t/g;         $w[17]=~s/=title=|=prop=/userlock/g;
          $w[17]=~s/=action=/edit-userlock/;   $w[17]=~s/=list=/$w[0]/;
         }

         #join
         $c=join("\t",@w);
    }

    #debug
    # &print_array(@c);
  }

  $r=join("\n",@e);

  # debug
  #&print_array(@e);
  #&print_array(@r);

  &log_end;
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Encrypted filesystems with Autolock/user unlock/lock service (Pro feature)'</script>\n";

  # print table
  print &list2table($r);


  #autoservice running?
  print "<br><br>autolock service: ";
  $r=`ps axw | grep agent_autolock.pl | grep -v grep`;

  if ($r=~/autolock/) {
       print "running<br><br>";
  } else {
       print "not running<br><br>";
  }

  #exit;
}




###############################################
#end of my script, do not delete the line below
1;